﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2011.01.03.
 * Time: 15:29
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
//
using TetheredSun.Mathematics;

namespace TetheredSun.Medical
{
	/// <summary>
	/// Description of ShortTermVariability.
	/// </summary>
	public class ShortTermVariability : SuccessiveDifferenceParameter
	{
		public ShortTermVariability(string unit)
		{
			this.unit = unit;
			this.name = "Short-term variability";
			this.value = Double.NaN;
		}
		
		public ShortTermVariability() : this("s") { }
		
		public override double Evaluate(IList<double> intervals)
		{
			value = intervals.GetSum() / (Math.Sqrt(2.0) * (intervals.Count + 1));	// TODO: intervals.Count or intervals.Count + 1?
			return value;
		}
	}
}
